/**
 * AttributeExistsConstraint.java
 *
 * Created 199911051504
 *
 * @author Benjamin Keil
 * @author Matthew Farrellee
 */

package org.datamanager.constraint;

import org.datamanager.constraint.EntityConstraint;
import org.datamanager.kernel.Entity;
import org.datamanager.exception.DataManagerException;
import org.datamanager.tools.Debug;
import org.datamanager.kernel.AbstractEntityConstraint;

public class AttributeExistsConstraint extends AbstractEntityConstraint {
    
    private EntityConstraint attributeConstraint;

    public AttributeExistsConstraint(EntityConstraint attributeConstraint)
    {
	this.attributeConstraint = attributeConstraint;
    }

    public boolean describes(Entity defendant)
    {
	try {
	    Entity[] attributes = defendant.getAttributes(EntityConstraint.NONE);
	    
	    boolean doesMatch = false;
	    int index = 0;
	    
	    while (index < attributes.length && doesMatch != true) {
		doesMatch = attributeConstraint.accepts(attributes[index++]);
	    }
	    
	    return doesMatch;
	}
	catch (DataManagerException exception) {
	    Debug.assert("defendant.getAttributes(Constraint.NONE) threw: " +
			 exception);
	    
	    return false;
	}
    }
} // AttributeExistsConstraint