/**
 * NameEqualsConstraint.java
 * @author Benjamin Keil
 * @author Matthew Farrellee
 *
 * Created: 199910071638
 */

package org.datamanager.constraint;

import org.datamanager.kernel.Entity;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.AbstractEntityConstraint;

public class NameContainsConstraint extends AbstractEntityConstraint {

    private String name;

    public NameContainsConstraint(String name)
        {
        this.name = name;
        }

    public boolean describes(Entity defendant)
        {
        boolean temp = false;

        try
            {
		String entityName = defendant.getName();
		temp = (entityName.indexOf(name) != -1);
            }
        catch (DataManagerException e)
            {
            e.printStackTrace();
            }
        return temp;
        }

    } // NameContainsConstraint

