/**
 * NameEqualsIgnoringCaseConstraint.java
 * @author Matthew Farrellee
 */

package org.datamanager.constraint;

import org.datamanager.kernel.Entity;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.AbstractEntityConstraint;

public class NameEqualsIgnoringCaseConstraint
	extends AbstractEntityConstraint
	{

    private String name;

    public NameEqualsIgnoringCaseConstraint(String name)
        {
        this.name = name;
        }

    public boolean describes(Entity defendant)
        {
        try
            {
            return name.equalsIgnoreCase(defendant.getName());
            }
        catch (DataManagerException e)
            {
            e.printStackTrace();
            }
        return false;
        }

    } // NameEqualsConstraint

