/**
 * ValueClassIsConstraint.java
 * @author Matthew Farrellee
 */

package org.datamanager.constraint;

import org.datamanager.kernel.Entity;
import org.datamanager.kernel.EntityValue;
import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.AbstractEntityConstraint;

public class ValueClassIsConstraint
	extends AbstractEntityConstraint
	{

	private Class target;

	public ValueClassIsConstraint(Class target)
		{
		this.target = target;
		}

	public boolean describes(Entity defendant)
		{
		EntityValue val;

		try
			{
			val = defendant.getValue();

			return val.getClass().isAssignableFrom(target);
			}
		catch (DataManagerException e)
			{
			e.printStackTrace();
			}

		return false;
		}
	}