/**
 * ValueInRangeConstraint.java
 * @author Benjamin Keil
 * @author Matthew Farrellee
 *
 * Created 199910111458
 */

package org.datamanager.constraint;

//import java.io.Serializable;

import org.datamanager.kernel.EntityValue;

import org.datamanager.kernel.Entity;

import org.datamanager.passiveentityvalue.NumericEntityValue;

import org.datamanager.exception.DataManagerException;

import org.datamanager.kernel.AbstractEntityConstraint;

public class ValueInRangeConstraint extends AbstractEntityConstraint {
    
    private double low, high;

    public ValueInRangeConstraint(double low, double high)
        {
        this.low = low;
        this.high = high;
        }

    public boolean describes(Entity defendant)
    {
	try {
		if (defendant == null)
			return false;
		
	    EntityValue val = defendant.getValue();
	    
	    if ((val instanceof NumericEntityValue) && (val != null))
		return ((NumericEntityValue)val).isInRange(low, high);
	    else
		return false;
	} catch (DataManagerException e) {
	    e.printStackTrace();
	}

	return false;
    }    
} // ValueInRangeConstraint