package org.datamanager.engine.filter;

/**
 * This class creates a weighted word from a word. 
 * Weighted word is a string with attached count and double weight
 * between 0.0 and 1.0.
 *
 * @author Aleksander Slominski
 */


public class WeightedWord implements org.datamanager.kernel.EntityValue {
    /** @serial */
    String word;
    /** @serial */
    int count;
    /** @serial */
    double weight;

    public WeightedWord(String word){
	this.word = word;
	count = 1;
	weight = 0;
    }


    /** Method increments the count of the words*/
    public void increment() {
	++count;
    }

/** Method returns the count of the words. */
    public int getCount() {
	return count;
    }

    public double getWeight() {
	return weight;
    }

    public String getWord() {
	return word;
    }


}
