package org.datamanager.engine.test;


import org.datamanager.engine.filter.*;
import java.io.*;

/**
 * This class is for testing the whole filtering process. 
 * It takes as arguments 
 * filters (Class names) and document to be filtered. 
 */



public class FilterTester {

    /**
     * @throws IOException, ClassNotFoundException, IllegalAccessException, InstantiationException
     */
   public static void main(String args[]) throws IOException, ClassNotFoundException, IllegalAccessException, InstantiationException {
    int count = args.length-1;
    CompositeFilter pipeline = new CompositeFilter();
    for(int i = 0; i < count; ++i) {
	String filterName = args[i];
	if(filterName.indexOf(".") == -1)
	    filterName = "org.datamanager.engine.filter." + filterName;
	Class c = Class.forName(filterName);
	Filter filter = (Filter) c.newInstance();
	pipeline.addFilter(filter);
    }
    StringBuffer buffer = new StringBuffer();
    String fileName = args[args.length -1];
    BufferedReader bufferReader = new BufferedReader(new FileReader(fileName));
    String line;
    while ( (line = bufferReader.readLine() ) != null ) {
	buffer.append(line);
    }
    Object input = buffer.toString();
    Object output = pipeline.process(input);
    System.out.println(output.toString());
  }
}

