package org.datamanager.engine.test;

import org.datamanager.engine.filter.*;
import java.io.*;
import test.framework.*;

/**
 * Simple module tests with JUnit.
 * 
 * This class is used to test FrequencyFilter.java class. It extends TestCase and it's constructor
 * takes a string name as its argument.
 * 
 * @author Aleksander Slominski
 */

public class FrequencyFilterTest extends TestCase {

    public FrequencyFilterTest(String name) {
        super(name);
    }

    public void testStringFiltering() {
       FrequencyFilter filter = new FrequencyFilter();
       String input = "Alice has a cat. The cat is nice.";
       WeightedWordList wl = (WeightedWordList) filter.process(input);
       //
       WeightedWord w = (WeightedWord) wl.get("cat");
       assertEquals(w.getCount(), 2);
       assert(w.getWeight() == 1.0);
       //System.out.println("ssdsdsd"+wl);
    }

    public static Test suite() {
        TestSuite suite= new TestSuite();

        suite.addTest(new FrequencyFilterTest("testStringFiltering"));
        return suite;
    }

    public static void main (String[] args) {
        test.textui.TestRunner.run (suite());
    }
}
