package org.datamanager.event;

import org.datamanager.event.PoolEvent;
import org.datamanager.event.GenericEvent;
import org.datamanager.kernel.EventGenerator;
import org.datamanager.kernel.Entity;

import org.datamanager.engine.Cluster;

/**
 * This even is fired by simpletons to point that document 
 * is available for further processing (ex. by Engine).
 *
 * @author Aleksander Slominski
 */
public class DocumentDownloadedEvent extends GenericEvent implements EngineEvent {
   /**
    */
   private Entity entity;


   /**
    * Construct event that entity was clustered.
    */
   public DocumentDownloadedEvent(EventGenerator source, Entity entity) {
      super(source);
      this.entity = entity;
   }


   /**
    * Return what cluster was added.
    */
   public Entity getEntity() {
      return entity;
   }

   
   /**
    */
   public String toString()
      {
      return "DocumentDownloadedEvent[[source: " + source + "]" +
             "[entity: " + entity + "]" +
             "[time: " + time + "]]";
      }
   }
