package org.datamanager.event;

import org.datamanager.event.PoolEvent;
import org.datamanager.event.GenericEvent;
import org.datamanager.kernel.EventGenerator;
import org.datamanager.kernel.Entity;

import org.datamanager.engine.Cluster;

/**
 * This even is fired by Engine  simpleton when new cluster is created.
 *
 * @author Aleksander Slominski
 */
public class EngineClusterCreatedEvent extends GenericEvent implements EngineEvent {
   /**
    */
   private Entity cluster;


   /**
    * Construct event caused by source entity to created cluster.
    */
   public EngineClusterCreatedEvent(EventGenerator source, Entity cluster) {
      super(source);
      this.cluster = cluster;
   }


   /**
    * Return what cluster was added.
    */
   public Entity getAddedCluster() {
      return cluster;
   }

   
   /**
    */
   public String toString()   {
	  return "EngineClusterCreatedEvent[[source: " + source + "]" +
	      "[cluster: " + cluster + "]" ;//+
	  //"[time: " + time + "]]";
   }
}
