package org.datamanager.event;

import org.datamanager.event.PoolEvent;
import org.datamanager.event.GenericEvent;
import org.datamanager.kernel.EventGenerator;
import org.datamanager.kernel.Entity;

import org.datamanager.engine.Cluster;

/**
 * This even is fired by Engine  simpleton when new cluster is created.
 *
 * @author Aleksander Slominski
 */
public class EngineClusteredEntityEvent extends GenericEvent implements EngineEvent {
   /**
    */
   private Entity entity;
   private Entity cluster;


   /**
    * Construct event that entity was clustered.
    */
   public EngineClusteredEntityEvent(EventGenerator source, Entity entity, Entity cluster) {
      super(source);
      this.entity = entity;
      this.cluster = cluster;
   }


   /**
    * Return what entity was added.
    */
   public Entity getEntity() {
      return entity;
   }


   /**
    * Return what cluster was added.
    */
   public Entity getCluster() {
      return cluster;
   }

   
   /**
    */
   public String toString(){
	  return "EngineClusteredEntityEvent[" + //[source: " + source + "]" +
	      "[entity: " + entity + "]" +
	      "[cluster: " + cluster + "]" ; //+
	      //"[time: " + time + "]]";
      }
   }
