package org.datamanager.event;

import org.datamanager.event.ValueEvent;
import org.datamanager.event.GenericEvent;
import org.datamanager.kernel.EventGenerator;

/**
 * This event is fired when <code>Entity.getValue()</code>
 * is invoked.
 *
 * @author Matthew Farrellee
 */
public class GetValueEvent
   extends GenericEvent
   implements ValueEvent
   {
   /**
    * The public constructor used to create a
    * <code>GetValueEvent</code>.
    *
    * @param source The source of this event. Usually 'this.'
    */
   public GetValueEvent(EventGenerator source)
      {
      super(source);
      }


   /**
    * A toString() method to provide a meaningful <code>String</code>
    * representation of this event.
    *
    * @return String A meaningful <code>String</code> representation
    *            of this event.
    */
   public String toString()
      {
      return "GetValueEvent[[source: " + source + "]" + "[time: " +
            time + "]]";
      }
   }
