/**
 * EventHandlerRunner.java
 */

package org.datamanager.kernel;

import org.datamanager.kernel.EventHandler;
import org.datamanager.kernel.DataManagerThread;
import org.datamanager.kernel.DataManagerWorker;
import org.datamanager.event.DataManagerEvent;


/**
 * @author Matthew Farrellee
 */ 
class EventHandlerRunner
	implements DataManagerWorker
   {
   private EventHandler handler;
   private DataManagerEvent event;

   EventHandlerRunner()
      {
      // Does nothing right now.
      }

   void reset(EventHandler handler, DataManagerEvent event)
      {
      this.handler = handler;
      this.event = event;
      }

   public void process()
      {
      handler.handle(event);

      // Notify something that this thread is now free
      // again.
      }

   EventHandler getEventHandler()
      {
      return handler;
      }

   DataManagerEvent getDataManagerEvent()
      {
      return event;
      }

   public String toString()
      {
      return "EventHandlerRunner[handler: " + handler + "]" +
            "[event: " + event + "]";
      }
   }
