/**
 * class ThreadManager
 */

package org.datamanager.kernel;

import org.datamanager.kernel.DataManagerThread;

import org.datamanager.kernel.DataManagerWorker;

import org.datamanager.kernel.InitializableRunner;
import org.datamanager.kernel.EventHandlerRunner;

import org.datamanager.kernel.Simpleton;
import org.datamanager.kernel.Initializable;
import org.datamanager.kernel.EventHandler;

import org.datamanager.event.DataManagerEvent;

/**
 * @author Matthew Farrellee
 */
class ThreadManager
	{

	private ThreadManager()
		{
		}

	static ThreadManager getInstance()
		{
		return new ThreadManager();
		}

	static void register(DataManagerWorker worker)
		{
		DataManagerThread thread = new DataManagerThread();
		thread.reset(worker);
		thread.start();
		}

	static void register(DataManagerWorker worker, int priority)
		{
		DataManagerThread thread = new DataManagerThread();
		thread.reset(worker);
		thread.setPriority(priority);
		thread.start();
		}

	static void register(EventHandler handler, DataManagerEvent event)
		{
		EventHandlerRunner runner = new EventHandlerRunner();
		runner.reset(handler, event);
		DataManagerThread thread = new DataManagerThread();
		thread.reset(runner);
		thread.start();
		}

	static void register(Initializable initializable)
		{
		InitializableRunner runner = new InitializableRunner();
		runner.reset(initializable);
		DataManagerThread thread = new DataManagerThread();
		thread.reset(runner);
		thread.start();
		}
	}
