/**
 * ThreadRegistry.java
 */

package org.datamanager.kernel;

import org.datamanager.kernel.DataManagerWorker;

/**
 * @author Matthew Farrellee
 */
public class WorkerRegistry
	{
	private static WorkerRegistry instance = new WorkerRegistry();

	private WorkerRegistry()
		{
		}

	public static WorkerRegistry getInstance()
		{
		return instance;
		}

	public void register(DataManagerWorker worker, int priority)
		{
		ThreadManager.register(worker, priority);
		}

	public void register(DataManagerWorker worker)
		{
		ThreadManager.register(worker);
		}
	}