/**
 * class BooleanEntityValue
 *
 * @author Benjamin Keil
 * @author Matthew Farrellee
 */

package org.datamanager.passiveentityvalue;

public class BooleanEntityValue implements PassiveEntityValue
    {
    private Boolean bool;

    public static final BooleanEntityValue TRUE =
            new BooleanEntityValue(true);

    public static final BooleanEntityValue FALSE =
            new BooleanEntityValue(false);

    public BooleanEntityValue()
        {
        }

    public BooleanEntityValue(boolean value)
        {
        bool = new Boolean(value);
        }

    public BooleanEntityValue(String s)
        {
        bool = new Boolean(s);
        }

    public boolean booleanValue()
        {
        return bool.booleanValue();
        }

    public boolean equals(Object obj)
        {
        try
        	{
        	return bool.booleanValue() == ((BooleanEntityValue) obj).booleanValue();
        	}
        catch (ClassCastException wrongType)
        	{
        	return false;
        	}
        }

    public static boolean getBoolean(String name)
        {
        return Boolean.getBoolean(name);
        }

    public int hashCode()
        {
        return bool.hashCode();
        }

    public String toString()
        {
        if (bool.booleanValue())
            {
            return "BooleanEntityValue.TRUE";
            }
        else
            {
            return "BooleanEntityValue.FALSE";
            }
        }

    public static Boolean valueOf(String s)
        {
        return Boolean.valueOf(s);
        }

    }
