package org.datamanager.passiveentityvalue;

import org.datamanager.passiveentityvalue.PassiveEntityValue;

import javax.mail.Flags;

/**
Author: gregory j. e. rawlins
Date: December 7, 1999

Responsibilities:
Objects of this class store various email message flags and can be
stored in an Entity as they are EntityValues.
**/
public class EmailMessageFlagsEntityValue
	extends Flags
	implements PassiveEntityValue
	{
	private Flags flags;

	public EmailMessageFlagsEntityValue(Flags flags)
		{
		super(flags);
		this.flags = flags;
		}

	public Flags getFlags()
		{
		return flags;
		}

	public boolean equals(Object value)
		{
		return flags.equals(value);
		}

	public int hashCode()
		{
		return flags.hashCode();
		}

	public String toString()
		{
		return flags.toString();
		}
	}
