/**
 * class VectorEntityValue
 *
 * @author Gordon Murphy
 */

package org.datamanager.passiveentityvalue;

import java.util.Vector;
import java.util.Collection;

public class VectorEntityValue implements PassiveEntityValue
    {
    private Vector vector;

    public VectorEntityValue()
        {
        vector = new Vector();
        }

    public VectorEntityValue(Vector vector)
        {
        this.vector = vector;
        }

    public VectorEntityValue(int size)
        {
        vector = new Vector(size);
        }

    public VectorEntityValue(Collection collection)
        {
        vector = new Vector(collection);
        }

    public void add(int index, Object object)
        {
        vector.add(index, object);
        }

    public void addElement(Object obj)
        {
        vector.addElement(obj);
        }

    public Object elementAt(int index)
        {
        return vector.elementAt(index);
        }
    public Object remove(int index)
        {
        return vector.remove(index);
        }
    public boolean remove(Object object)
        {
        return vector.remove(object);
        }
    public void removeAllElements()
        {
        vector.removeAllElements();
        }

    public int hashCode()
        {
        return vector.hashCode();
        }

    public String toString()
        {
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("VectorEntityValue: ");
        for (int i = 0; i < vector.size(); i++)
            {
            stringBuffer.append(vector.elementAt(i).toString());
            }
        return stringBuffer.toString();
        }
    public Vector getVector()
        {
        return vector;
        }
    public int size()
        {
        return vector.size();
        }
    public boolean equals(Object object)
        {
        return vector.equals(object);
        }
    }
