package org.datamanager.userinterface.cerulean.controller.cluster;

import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import java.awt.*;

public class BufferClusterListener extends ClusterAdapter {
	private BufferComponent bufferComponent;
	private Buffer buffer;
	private InterfaceEntityPeerTable peerTable;
	public BufferClusterListener(BufferComponent bufferComponent) {
		this.bufferComponent = bufferComponent;
		this.buffer = bufferComponent.getBuffer();
		peerTable = InterfaceEntityPeerTable.getInstance();
		}
	public void entitiesAddedToCluster(ClusterContentEvent e) {
		if (e.getCluster() == buffer) {
			InterfaceEntityList entities = e.getEntities();
			for (int i = 0; i <= entities.size() - 1; i++) {
				InterfaceEntity entity = entities.elementAt(i);
				InterfaceEntityComponent entityComponent = peerTable.getPeer(entity);
				bufferComponent.add(entityComponent);
				}
			}
		}
	public void entitiesRemovedFromCluster(ClusterContentEvent e) {
		InterfaceEntityPeerTable table = InterfaceEntityPeerTable.getInstance();
		if (e.getCluster() == buffer) {
			InterfaceEntityList entities = e.getEntities();
			for (int i = 0; i <= entities.size() - 1; i++) {
				InterfaceEntity entity = entities.elementAt(i);
				InterfaceEntityComponent entityComponent = peerTable.getPeer(entity);
				bufferComponent.remove(entityComponent);			
				}
			buffer.removeEntities(entities, true);
			bufferComponent.repaint();
			}
		}
	public void entitiesReclustered(ClusterReclusteringEvent e) {
		InterfaceEntityPeerTable table = InterfaceEntityPeerTable.getInstance();
		if (e.getOldClusters().contains(buffer)) {
			InterfaceEntityList entities = e.getEntitiesReclusteredFrom(buffer);
			for (int i = 0; i <= entities.size() - 1; i++) {
				InterfaceEntity entity = entities.elementAt(i);
				InterfaceEntityComponent entityComponent = peerTable.getPeer(entity);
				bufferComponent.remove(entityComponent);			
				}
			bufferComponent.repaint();
			}
		else if (e.getCluster() == buffer) {
			InterfaceEntityList entities = e.getEntities();
			for (int i = 0; i <= entities.size() - 1; i++) {
				InterfaceEntity entity = entities.elementAt(i);
				InterfaceEntityComponent entityComponent = peerTable.getPeer(entity);
				bufferComponent.add(entityComponent);
				}			
			bufferComponent.repaint();
			}
		}
	}