package org.datamanager.userinterface.cerulean.controller.cluster;

import org.datamanager.userinterface.cerulean.model.event.ClusterEvent;
import org.datamanager.userinterface.cerulean.model.event.ClusterAdapter;
import org.datamanager.userinterface.cerulean.model.event.ClusterReclusteringEvent;
import org.datamanager.userinterface.cerulean.model.event.ClusterContentEvent;
import org.datamanager.userinterface.cerulean.model.InterfaceCluster;
import org.datamanager.userinterface.cerulean.model.InterfaceEntity;
import org.datamanager.userinterface.cerulean.model.Stage;
import org.datamanager.userinterface.cerulean.model.data.storage.ClusterList;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.tools.Debug;
public class StageClusterListener extends ClusterAdapter {
	private Stage stage;
	public StageClusterListener(Stage stage) {
		this.stage = stage;
		}
	public void clusterAdded(ClusterEvent e) {
		}
	public void clusterRemoved(ClusterEvent e) {
		}
	public void clusterSelected(ClusterEvent e) {	
		stage.addCluster(e.getCluster());
		}
	public void clusterUnselected(ClusterEvent e) {
		stage.removeCluster(e.getCluster());
		}
	public void entitiesAddedToCluster(ClusterContentEvent e) {
		InterfaceCluster cluster = e.getCluster();
		ClusterList list = stage.getClusterList();
		if (list.contains(cluster)) {
			stage.addEntities(e.getEntities());
			}
		}
	public void entitiesRemovedFromCluster(ClusterContentEvent e) {
		InterfaceCluster cluster = e.getCluster();
		ClusterList list = stage.getClusterList();
		if (list.contains(cluster)) {
			stage.removeEntities(e.getEntities());
			}
		}
	public void entitiesReclustered(ClusterReclusteringEvent e) {
		InterfaceCluster newCluster = e.getNewCluster();
		ClusterList oldClusters = e.getOldClusters();
		ClusterList list = stage.getClusterList();
		InterfaceEntityList entities;
		InterfaceCluster oldCluster;
		Debug.assert("Reclustering in Stage");
		for (int i = 0; i <= oldClusters.size() - 1; i++) {
			oldCluster = oldClusters.elementAt(i);
			entities = e.getEntitiesReclusteredFrom(oldCluster);
			if (!list.contains(newCluster) && list.contains(oldCluster)) {
				stage.removeEntities(entities);
				}
			else if (list.contains(newCluster) && !list.contains(oldCluster)) {
				stage.addEntities(entities);
				}
			}
		}
	}