package org.datamanager.userinterface.cerulean.controller.drop;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.InterfaceEntityComponent;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.InterfaceEntityTransferable;
import org.datamanager.userinterface.cerulean.model.data.storage.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.util.List;
import java.util.Iterator;

import java.io.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.DefaultListModel;

public class InterfaceEntityDragListener implements DragSourceListener, DragGestureListener {

	private DropTarget dropTarget;
	private String localFlavor;
	private DragSource dragSource;
	private InterfaceEntityComponent entity;
	private Transferable transferable;
	public InterfaceEntityDragListener(InterfaceEntityComponent entity) {
		this.entity = entity;
		dragSource = DragSource.getDefaultDragSource();
		dragSource.createDefaultDragGestureRecognizer( entity, DnDConstants.ACTION_MOVE, this);
		transferable = new InterfaceEntityTransferable(entity);
		}
	public void dragGestureRecognized( DragGestureEvent event) {
		try {
			dragSource.startDrag(event, null, transferable, this);
			}
		catch (InvalidDnDOperationException e) {
			System.out.println( "selected2");   
			System.out.println(""+e);
			}
		}
	public void dragDropEnd (DragSourceDropEvent event) {   
		System.out.println("dragging over");
		if ( event.getDropSuccess()) {
			System.out.println("drag successful");	
			}
		else {
			System.out.println("drag unsuccessful");
			}
		}
	public void dragEnter (DragSourceDragEvent event) {
		}
	public void dragExit (DragSourceEvent event) {
		}
	public void dragOver (DragSourceDragEvent event) {
		//System.out.println( "dragOver");
		}
	public void dropActionChanged ( DragSourceDragEvent event) {
		System.out.println( "dropActionChanged"); 
		}
	}
