package org.datamanager.userinterface.cerulean.controller.drop;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import java.awt.event.*;
import java.util.Hashtable;
import java.util.List;
import java.util.Iterator;

import java.io.*;
import java.io.IOException;

import javax.swing.*;
import javax.swing.DefaultListModel;

public class StageDropListener extends InterfaceDropListener {
	private StageComponent stageComponent;
	private Stage stage;
	public StageDropListener(StageComponent stageComponent) {
		super(stageComponent);
		this.stageComponent = stageComponent;
		this.stage = stageComponent.getStage();
		}
	public void performDropAction(InterfaceEntityList list, InterfaceEntityComponent selectedEntity, DropTargetDropEvent event) {
		Point location = event.getLocation();
		InterfaceEntityList stageEntityList = stage.getInterfaceEntityList();
		//System.out.println("performing action");
		int x = selectedEntity.getLocation().x;
		int y = selectedEntity.getLocation().y;
		int movedX = location.x - x;
		int movedY = location.y - y;
		for (int i = 0; i <= list.size() - 1; i++) {
			InterfaceEntity entity = list.elementAt(i);
			if(!stageEntityList.contains(entity)) {
				//System.out.println("rejecting");
				//event.rejectDrop();
				}
			else {
				entity.setRelativeMoved(stageComponent, movedX, movedY);
				}
			}
		}
	}