package org.datamanager.userinterface.cerulean.controller.mouse;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.controller.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.menu.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
public class StageMouseListener extends MouseAdapter implements MouseMotionListener {
	private StageComponent stageComponent;
	private StagePopupMenu popupMenu;
	private boolean isSelecting;
	private Point originalSelectionPoint;
	public StageMouseListener (StageComponent stageComponent) {
		this.stageComponent = stageComponent;
		popupMenu = new StagePopupMenu(stageComponent);
		isSelecting = false;
		originalSelectionPoint = new Point(0,0);
		}
	//store the position of the initial 
	public void mousePressed(MouseEvent e) {
		System.out.println("pressed");
		if (e.isPopupTrigger()) {
			popupMenu.show(stageComponent, e.getX(), e.getY());
			}
		else {
			isSelecting = true;
			originalSelectionPoint = e.getPoint();
			}
		}
	public void mouseReleased(MouseEvent e) {
		System.out.println("released");
		if (e.isPopupTrigger()) {
			popupMenu.show(stageComponent, e.getX(), e.getY());
			}
		else if (!originalSelectionPoint.equals(e.getPoint()) && isSelecting) {
			isSelecting = false;
			stageComponent.setDrawingSelectionBoxEnabled(false);
			stageComponent.groupEntitiesAt(originalSelectionPoint, e.getPoint());
			stageComponent.repaint();
			}
		isSelecting = false;
		}
	public void mouseEntered(MouseEvent e) {
		}
	public void mouseClicked(MouseEvent e) {
		stageComponent.ungroupAllEntities();
		}
	public void mouseExited(MouseEvent e) {
		}
	public void mouseDragged(MouseEvent e) {
		if (isSelecting) {
			System.out.println("selection box");
			stageComponent.drawSelectionBox(originalSelectionPoint, e.getPoint());
			}
		}
	public void mouseMoved(MouseEvent e) {
		}
	}