package org.datamanager.userinterface.cerulean.controller.stage;

import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import org.datamanager.tools.Debug;
import java.awt.*;
import javax.swing.*;
import java.util.EventListener;

public class StageComponentStageListener implements StageListener {
	private StageComponent stageComponent;
	private InterfaceEntityPeerTable peerTable;
	public StageComponentStageListener(StageComponent stageComponent) {
		this.stageComponent = stageComponent;
		peerTable = InterfaceEntityPeerTable.getInstance();
		}
	public void entitiesDisplayed(StageEvent event){
		System.out.println("displaying");
		InterfaceEntityList entities = event.getEntities();
		for (int i = 0; i <= entities.size() - 1; i++) {
			InterfaceEntity entity = entities.elementAt(i);
			InterfaceEntityComponent component;
			//System.out.println("Displayed"+entity.getName());
			component = peerTable.getPeer(entity);
			Point location = component.getLocation();
			if(stageComponent.contains(location.x, location.y)) {
				component = peerTable.getPeer(entity);
				//entity.setMoved(stageComponent, location.x, location.y);
				}
			else {
				Insets insets = stageComponent.getInsets();
				int x = (stageComponent.getWidth() - insets.left - insets.right)/2;
				int y = (stageComponent.getHeight() - insets.top - insets.bottom)/2;
				int usableWidth = (int)((Math.cos(Math.PI/4) * x) * 2);
				int usableHeight = (int)((Math.sin(Math.PI/4) * y) * 2);
				int offsetX = x - usableWidth/2 + insets.left;
				int offsetY = y - usableHeight/2 + insets.top;
				location = component.getClustering(usableWidth, usableHeight);
				System.out.println(""+location);
				entity.setMoved(stageComponent, location.x + offsetX - component.getWidth(), location.y + offsetY - component.getHeight());
				}
			stageComponent.add(component);
			}
		System.out.println("displayed entities in stage listener");
		stageComponent.repaint();
		System.out.println("displayed entities in stage listener");
		}
	public void entitiesUndisplayed(StageEvent event){
		System.out.println("Undisplayed");
		InterfaceEntityList entities = event.getEntities();
		for (int i = 0; i <= entities.size() - 1; i++) {
			InterfaceEntity entity = entities.elementAt(i);
			InterfaceEntityComponent entityComponent = peerTable.getPeer(entity);
			stageComponent.remove(entityComponent);
			}
		Debug.assert("undisplayed entities in stage listener");
		stageComponent.repaint();
		//Debug.assert("undisplayed entities in stage listener - after repaint");
		}
	}