/*
KnownSpace: Cerulean
class org.datamanager.userinterface.cerulean.model.Buffer

Authors:
~~~~~~~~
Gordon Murphy, gpmurphy@indiana.edu
Bryan Dawson, bdawson@indiana.edu
*/
package org.datamanager.userinterface.cerulean.model;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.controller.drop.*;
import org.datamanager.userinterface.cerulean.controller.entity.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
/**
 * The buffer is the graphical representation of a kind of "clip board".  
 * Items can be dragged and dropped into the buffer, where they are stored.
 * Once items are stored in the buffer, they cannot be dragged directly onto
 * the stage, rather, they must be dragged to a cluster.
 *
 * @see Circle
 * @see CircleManager
 * @see InterfaceEntityManager
 * @see CircleIcon
 * @see BufferDropListener
 * @see BufferEntityListener
 *
 * @version 1.0
 * @author Gordon Murphy, gpmurphy@indiana.edu
 * @author Bryan Dawson, bdawson@indiana.edu 
 */

public class Buffer extends InterfaceCluster implements Serializable {

/**
 * Creates a new Buffer
 */
	public Buffer() {
		super("Buffer");
		}
	}