package org.datamanager.userinterface.cerulean.model;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.controller.drop.*;
import org.datamanager.userinterface.cerulean.controller.entity.*;
import org.datamanager.userinterface.cerulean.controller.cluster.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;
public class CeruleanProgressMonitor extends JPanel implements InterfaceProgressMonitor {
	private static CeruleanProgressMonitor monitor = new CeruleanProgressMonitor();
	private Image animatedLogo, stillLogo;
	private boolean isRunning;
	private String animatedLogoAddress, stillLogoAddress;
	private CeruleanProgressMonitor() {
		animatedLogoAddress = "images/animatedLogo.gif";
		stillLogoAddress = "images/stillLogo.gif";
		animatedLogo = new ImageIcon(animatedLogoAddress).getImage();
		animatedLogo.flush();
		stillLogo = new ImageIcon(stillLogoAddress).getImage();
		}
	public static CeruleanProgressMonitor getInstance() {
		return monitor;
		}
	public void paintComponent(Graphics g) {
		if (isRunning)
			g.drawImage(animatedLogo, 1, 1, this);
		else {
			animatedLogo.flush();
			g.drawImage(stillLogo, 1, 1, this);
			}
		}
	public void startMonitor() {
		isRunning = true;
		}
	public void stopMonitor() {
		isRunning = false;
		}
	}