/*
class org.datamanager.userinterface.cerulean.model.data.storage.InterfaceAttributeList
KnownSpace: Cerulean

Authors:
~~~~~~~~
Gordon Murphy, gpmurphy@indiana.edu
Bryan Dawson, bdawson@indiana.edu
*/

////////////////////////////////////////////////////////////////////////////////

package org.datamanager.userinterface.cerulean.model.data.storage;

import org.datamanager.userinterface.cerulean.model.InterfaceAttribute;
import org.datamanager.userinterface.cerulean.model.InterfaceEntity;
import org.datamanager.kernel.Entity;
import java.util.Vector;
import java.io.Serializable;

////////////////////////////////////////////////////////////////////////////////
/**
 * InterfaceAttributeList is a container class for InterfaceAttributes.
 * 
 * @see InterfaceAttribute
 * @see InterfaceEntityList
 *
 * @author Gordon Murphy, gpmurphy@indiana.edu
 * @author Bryan Dawson, bdawson@indiana.edu
 */
public class InterfaceAttributeList extends InterfaceEntityList implements Serializable {
	private Vector entities;
	private static final int DEFAULT_NUMBER_OF_CLUSTERS = 20;

////////////////////////////////////////////////////////////////////////////////
/**
 * Create a new list of InterfaceAttributes
 */
	public InterfaceAttributeList() {
		super();
		}

////////////////////////////////////////////////////////////////////////////////
/**
 * Create a new list of InterfaceAttributes using the specified array of entities.
 */	
	public InterfaceAttributeList(Entity[] list) {
		this();
		Entity entity;
		InterfaceAttribute cEntity;
		for (int i=0; i <= list.length - 1; i++) {
			entity = list[i];
			cEntity = new InterfaceAttribute(entity);
			addEntity(cEntity);
			}
		}
	}