package org.datamanager.userinterface.cerulean.model.event;

import java.util.EventObject;
import org.datamanager.userinterface.cerulean.model.*;

/**
 * An event encapsulating the data necessary to relocate an entity.
 * This event is called when an InterfaceEntity is moved.  The coordinates
 * are relative to the coorinates of the interface system.
 */
public class EntityMovedEvent extends EntityEvent {
	protected int x,y,z;
/**
 * Create a new EntityMovedEvent representing a specific coordinate.
 */
	public EntityMovedEvent(Object source, InterfaceEntity entity, int x, int y, int z) {
		super(source, entity);
		setX(x);
		setY(y);
		setZ(z);
		}
	public EntityMovedEvent(Object source, InterfaceEntity entity, int x, int y) {
		this(source, entity, x, y, 0);
		}
	protected void setX(int x) {
		this.x = x;
		}
	protected void setY(int y) {
		this.y = y;
		}
	protected void setZ(int z) {
		this.z = z;
		}
	public int getX() {
		return x;
		}
	public int getY() {
		return y;
		}
	public int getZ() {
		return z;
		}
	}