package org.datamanager.userinterface.cerulean.model.event;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.storage.*;
import java.util.EventObject;

/**
 * StageEvent encapsulates the information needed when the
 * stage displays or undisplays entities.
 * 
 * @see InterfaceEntityList
 * @see StageListener
 * @see StageAdapter
 * @see Stage
 * @see StageComponent
 *
 * @author Gordon Murphy, gpmurphy@indiana.edu
 * @author Bryan Dawson, bdawson@indiana.edu
 */
public class StageEvent extends EventObject {
	private Stage stage;
	private InterfaceEntityList entities;
	public StageEvent(Object source, InterfaceEntityList entities) {
		super(source);	
		setEntities(entities);
		}
	private void setEntities(InterfaceEntityList entities) {
		this.entities = entities;
		}
/**
 * Return a list of the entities to be displayed.
 * @return a list of entities to be displayed.
 */
	public InterfaceEntityList getEntities() {
		return entities;
		}
	}