package org.datamanager.userinterface.cerulean.model.event;

import java.util.EventListener;

/**
 * The interface that must be implemented by classes
 * wishing to listen for stage events.
 */
public interface StageListener extends EventListener {
/**
 * Called when the stage wishes to display its entities.
 * @param event a StageEvent
 */
	public void entitiesDisplayed(StageEvent event);
/**
 * Called when the stage wishes to undisplay its entities.
 * @param event a StageEvent
 */
	public void entitiesUndisplayed(StageEvent event);
	}