/**
interface
org.datamanager.userinterface.cerulean.model.event.UndoDiedListener

Authors:
~~~~~~~
Bryan Dawson, bdawson@indiana.edu
Gordon Murphy, gpmurphy@indiana.edu

Description:
~~~~~~~~~~~~
This interface should be implemented by any class that wants to know when
a CeruleanUndoEdit dies.  The implementing class would be sent an 
UndoableEditEvent to get the dieing edit. 

Methods:
~~~~~~~~
public abstract void undoEditDied(UndoableEditEvent)
          lets the implementing class get the dieing edit

Other classes to see:
~~~~~~~~~~~~~~~~~~~~~
org.datamanager.userinterface.cerulean.model.undo.HistoryListModel
org.datamanager.userinterface.cerulean.modle.undo.CeruleanUndoManager

**/
//////////////////////////////////////////////////////////////////////

package org.datamanager.userinterface.cerulean.model.event;

import javax.swing.event.UndoableEditEvent;

public interface UndoDiedListener 
   {
   public abstract void undoEditDied(UndoableEditEvent e);
   }


