package org.datamanager.userinterface.cerulean.model.event.cluster;

import org.datamanager.userinterface.cerulean.model.Stage;
import org.datamanager.userinterface.cerulean.model.InterfaceEntity;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.userinterface.cerulean.model.CircleManager;
import org.datamanager.userinterface.cerulean.model.event.*;

public abstract class ClusterEventThread implements Runnable {
	private ClusterEvent event;
	private Object[] listeners;
	public ClusterEventThread(ClusterEvent event, Object[] listeners) {
		this.event = event;
		this.listeners = listeners;
		}
	public void run() {
		System.out.println("running thread");
		for(int i = listeners.length - 2; i>=0; i-=2) {
			performAction((ClusterListener)listeners[i+1]);
			}
		System.out.println("finished thread");
		}
	public abstract void performAction(ClusterListener listener);
	public ClusterEvent getEvent() {
		return event;
		}
	}