package org.datamanager.userinterface.cerulean.model.event.stage;

import org.datamanager.userinterface.cerulean.model.Stage;
import org.datamanager.userinterface.cerulean.model.InterfaceEntity;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.userinterface.cerulean.model.CircleManager;
import org.datamanager.userinterface.cerulean.view.component.StageComponent;
import org.datamanager.userinterface.cerulean.model.event.*;

public abstract class StageEventThread implements Runnable {
	private StageEvent event;
	private Object[] listeners;
	public StageEventThread(StageEvent event, Object[] listeners) {
		this.event = event;
		this.listeners = listeners;
		}
	public void run() {
		System.out.println("running thread");
		for(int i = listeners.length - 2; i>=0; i-=2) {
			performAction((StageListener)listeners[i+1]);
			}
		System.out.println("finished thread");
		}
	public abstract void performAction(StageListener listener);
	public StageEvent getEvent() {
		return event;
		}
	}
