/*
class org.datamanager.userinterface.cerulean.model.kernel.AddEventWorker
KnownSpace: Cerulean

Authors:
~~~~~~~~
Gordon Murphy, gpmurphy@indiana.edu
Bryan Dawson, bdawson@indiana.edu
*/
////////////////////////////////////////////////////////////////////////////////

package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.event.DataManagerEvent;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;

////////////////////////////////////////////////////////////////////////////////
/**
 * Adds an event to the Kernel's pool.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class AddEventWorker extends InterfaceWorker {
	private DataManagerEvent event;
////////////////////////////////////////////////////////////////////////////////
/**
 * Add a new event to the pool.
 * @param the event to add
 */
	public AddEventWorker(DataManagerEvent event) {
		this.event = event;
		}
	protected Object construct() {
		try {
			Pool.getDefaultPool().add(event);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
