//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;

////////////////////////////////////////////////////////////////////////////////
/**
 * Detaches an entity as an attribute to another entity.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */

public class DetachEntityWorker extends InterfaceWorker {
	private Entity base, attribute;
/**
 * Detach attribute as an attribute to base
 * @param base the entity the attribute will be detached from
 * @param attribute the entity that will detach itself
 */	
	public DetachEntityWorker(Entity base, Entity attribute) {
		this.base = base;
		this.attribute = attribute;
		}
	protected Object construct() {
		try {
			base.detach(attribute);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
