//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.constraint.EntityConstraint;
import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;

////////////////////////////////////////////////////////////////////////////////
/**
 * Retrieves all the bases of an entity matching a given constraint.
* A call to get() will retrieve the Entity[] as an Object.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */

public class GetBasesWorker extends InterfaceWorker {
	private Entity entity;
	private EntityConstraint constraint;
/**
 * Creates a worker to get all the bases of an entity.
 * @param entity the entity to get the bases of
 * @param constraint the constraint to match
 */
	public GetBasesWorker(Entity entity, EntityConstraint constraint) {
		this.entity = entity;
		this.constraint = constraint;
		}
	protected Object construct() {
		Entity[] entities = null;
		try {
			entities = entity.getBases(constraint);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return entities;
		}
	}
