//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;
import org.datamanager.userinterface.cerulean.model.data.storage.InterfaceEntityList;
import org.datamanager.constraint.EntityConstraint;
////////////////////////////////////////////////////////////////////////////////
/**
 * Searches for entities matching the given constraint
* A call to get() will retrieve the InterfaceEntityList as an Object.
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class SearchWorker extends InterfaceWorker {
	private EntityConstraint constraint;
/**
 * Creates a worker to search for all the entities matching the constraint
 * @param constraint the constraint to match
 */
	public SearchWorker(EntityConstraint constraint) {
		this.constraint = constraint;
		}
	protected Object construct() {
		InterfaceEntityList list = null;
		try {
			Entity[] entities = Pool.getDefaultPool().search(constraint);
			list = new InterfaceEntityList(entities);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return list;
		}
	}
