//////////////////////////////////////////////////////////////
package org.datamanager.userinterface.cerulean.model.kernel;

import org.datamanager.exception.DataManagerException;
import org.datamanager.kernel.Entity;
import org.datamanager.kernel.Pool;
import org.datamanager.kernel.EntityValue;

////////////////////////////////////////////////////////////////////////////////
/**
 * Sets the value of an entity to an EntityValue
 * <strong>Note: This thread will only work when run within the kernel on an 
 * approved thread.</strong>
 */
public class SetEntityValueWorker extends InterfaceWorker {
	private Entity entity;
	private EntityValue value;
/**
 * Creates a worker to set the value of an entity
 * @param entity the entity to have its value changed
 * @param value the value the entity will be set to
 */
	public SetEntityValueWorker(Entity entity, EntityValue value) {
		this.entity = entity;
		this.value = value;
		}
	protected Object construct() {
		try {
			entity.setValue(value);
			}
		catch (DataManagerException e) {
			e.printStackTrace();
			}
		return null;
		}
	}
