package org.datamanager.userinterface.cerulean.model.menu;

import org.datamanager.userinterface.cerulean.controller.action.ReclusterEntitiesAction;
import org.datamanager.userinterface.cerulean.model.InterfaceEntity;
import org.datamanager.userinterface.cerulean.model.InterfaceCluster;
import java.awt.event.ActionEvent;

/**
 * A menu that displays a list of available clusters.  When a cluster
 * is selected, the entity is then moved to that cluster.
 */

public class AddEntityToClusterMenu extends InterfaceClusterMenu {
	private InterfaceEntity entity;
/**
 * Create a new menu with the name defined by text.
 * @param text the name of the menu.
 * @param entity the entity to move.
 */
	public AddEntityToClusterMenu(String text, InterfaceEntity entity) {
		super(text);
		this.entity = entity;
		}
	public void addListener(InterfaceClusterMenuItem item) {
		ReclusterEntitiesAction action;
		action = new ReclusterEntitiesAction(item.getCluster());
		item.addActionListener(action);
		}
	}