/*
KnownSpace: Cerulean
class org.datamanager.userinterface.cerulean.model.BufferPane

Authors:
~~~~~~~~
Gordon Murphy, gpmurphy@indiana.edu
Bryan Dawson, bdawson@indiana.edu
*/

package org.datamanager.userinterface.cerulean.view.component;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import javax.swing.JComponent;
import javax.swing.JLayeredPane;

/**
 *
 * The buffer pane holds the buffer and sets its bounds to fill the entire panel.
 * The buffer pane is added to the CRootPane.
 * 
 * @see Buffer
 * @see Shape
 * 
 * @version 1.0
 * @author Gordon Murphy, gpmurphy@indiana.edu
 * @author Bryan Dawson, bdawson@indiana.edu 
 */

public class BufferPane extends CirclePane {
	private BufferComponent buffer;
/**
 * Creates a new BufferPane with a Buffer already added to it
 */
	public BufferPane() {
		super();
		setLayout(new BorderLayout());
		setVisible(true);
		setOpaque(false);
		buffer = new BufferComponent();
		addImpl(buffer, BorderLayout.CENTER, -1);
		}
	}