package org.datamanager.userinterface.cerulean.view.icon;
import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.component.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.awt.geom.*;
public class InterfaceEntityIcon implements CIcon {
	private int currentWidth, currentHeight;
	private Point pressedCoordinates;
	private String entityName;
	private Shape iconShape;
	private Paint currentPaint;
	private static final Color GRAY_OUT_ICON_COLOR = new Color(128,128,128,192);
	public InterfaceEntityIcon(Paint currentPaint) {
		this.currentPaint = currentPaint;
		currentWidth = 10;
		currentHeight = 10;
		setIconShape(getDefaultIconShape());
		}
	public void paintIcon(Component c, Graphics g, int x, int y) {
		InterfaceEntityComponent component = (InterfaceEntityComponent)c;
		Graphics2D g2 = (Graphics2D)g;
		g2.setPaint(currentPaint);	
		g2.fill(getIconShape());
		if (component.isSelected()) {
			g2.setPaint(GRAY_OUT_ICON_COLOR);
			g2.fill(getIconShape());
			}
		}
	public void setPaint(Paint paint) {
		this.currentPaint = paint;
		}
	public Paint getPaint() {
		return currentPaint;
		}
	public int getIconWidth() {
		return getIconShape().getBounds().width;
		}
	public int getIconHeight() {
		return getIconShape().getBounds().height;
		}
	protected Shape getDefaultIconShape() {
		Ellipse2D.Double circle = new Ellipse2D.Double(0, 0, currentWidth, currentHeight);
//		Area a = new Area(circle);
//		Ellipse2D.Double circle1 = new Ellipse2D.Double(10, 10, currentWidth, currentHeight);
//		Area b = new Area(circle1);
//		a.add(b);
//		return a;
		return circle;
		}
	public void setIconShape(Shape iconShape) {
		this.iconShape = iconShape;
		}
	public Shape getIconShape() {
		return iconShape;
		}
	}
