package org.datamanager.userinterface.cerulean.view.layout;


/**
 * @version 1.20 7 Oct 1998
 * @author Cay Horstmann
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;
import java.awt.geom.*;
import org.datamanager.userinterface.cerulean.model.*;
public class StageLayout implements LayoutManager, LayoutManager2
{
   private int minWidth = 0;
   private int minHeight = 0;
   private int preferredWidth = 0, preferredHeight = 0;
   private boolean sizesSet = false;
   private int maxComponentWidth = 0;
   private int maxComponentHeight = 0;
   private double parentWidth = 0;
   private double parentHeight = 0;
   private Vector components;
   public StageLayout() 
	   {
		components = new Vector();
	   }
   public void addLayoutComponent(String name, Component comp)
   {}

   public void removeLayoutComponent(Component comp)
   {}

   public void setSizes(Container parent)
   {  if (sizesSet) return;
      int n = parent.getComponentCount();

      preferredWidth = 0;
      preferredHeight = 0;
      minWidth = 0;
      minHeight = 0;
      maxComponentWidth = 0;
      maxComponentHeight = 0;

      for (int i = 0; i < n; i++)
      {  Component c = parent.getComponent(i);
         if (c.isVisible()) {
         Dimension d = c.getPreferredSize();
         maxComponentWidth = Math.max(maxComponentWidth,
            d.width);
         maxComponentHeight = Math.max(maxComponentWidth,
            d.height);
         preferredHeight += d.height;
         }
      }
      preferredHeight += maxComponentHeight;
      preferredWidth = 2 * maxComponentWidth;
      minHeight = preferredHeight;
      minWidth = preferredWidth;
      sizesSet = true;
   }

   public Dimension preferredLayoutSize(Container parent)
   {  Dimension dim = new Dimension(0, 0);
      setSizes(parent);
      Insets insets = parent.getInsets();
      dim.width = preferredWidth + insets.left
         + insets.right;
      dim.height = preferredHeight + insets.top
         + insets.bottom;
      return dim;
   }

   public Dimension minimumLayoutSize(Container parent)
   {  Dimension dim = new Dimension(0, 0);
      setSizes(parent);
      Insets insets = parent.getInsets();
      dim.width = minWidth + insets.left + insets.right;
      dim.height = minHeight + insets.top + insets.bottom;
      return dim;
   }

	public void layoutContainer(Container parent) {
		Insets insets = parent.getInsets();
		Rectangle parentBounds = parent.getBounds();
		int n = parent.getComponentCount();
		if (parentBounds.width == 0 || parentBounds.height == 0) {
			parentWidth = parentBounds.width;
			parentHeight = parentBounds.height;
			}
		for (int i = 0; i < n; i++) {
			Component c = (Component)components.elementAt(i);
			if (c.isVisible()) {  
				Dimension d = c.getPreferredSize();
				Rectangle bounds = c.getBounds();
				int x = (int)((parentBounds.width/parentWidth)*bounds.x);
				int y = (int)((parentBounds.height/parentHeight)*bounds.y);
				c.setBounds(new Rectangle(x,y,bounds.width, bounds.height));
				}
			}
		parentWidth = parentBounds.width;
		parentHeight = parentBounds.height;
		}
   public void addLayoutComponent(Component comp, Object constraint)
	{
		components.addElement(comp);
	}
   public float getLayoutAlignmentX(Container target) 
	{
	   return (float).5;
	}
   public float getLayoutAlignmentY(Container target)
	{
		return (float).5;
	}
   public void invalidateLayout(Container target) 
	{
	}          
   public Dimension maximumLayoutSize(Container target) 
	{
	   return new Dimension(maxComponentWidth, maxComponentHeight);
	}
   
}

