package org.datamanager.userinterface.cerulean.view.viewer;

import org.datamanager.userinterface.cerulean.view.icon.*;

import org.datamanager.userinterface.cerulean.view.*;
import org.datamanager.userinterface.cerulean.view.viewer.*;
import org.datamanager.userinterface.cerulean.controller.drop.*;
import org.datamanager.userinterface.cerulean.controller.mouse.*;
import org.datamanager.userinterface.cerulean.controller.entity.*;
import org.datamanager.userinterface.cerulean.model.*;
import org.datamanager.userinterface.cerulean.model.event.*;
import org.datamanager.userinterface.cerulean.model.data.transfer.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import javax.swing.*;
import java.awt.geom.*;
import java.io.*;
/**
 * NewsViewer.  A very simple viewer that displays the header,
 * author, server, subject and message of a newsgroup article.
 */
public class NewsViewer extends JFrame {
	private String header, author, server, newsgroup, message, subject;
	private JEditorPane editorPane;
/**
 * Create a new NewsViewer
 */

	public NewsViewer() {
		editorPane = new JEditorPane();
		JScrollPane pane = new JScrollPane(editorPane);
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(pane, BorderLayout.CENTER);
		setSize(600, 480);
		}
	public void setHeader(String header) {
		this.header = header;
		}
	public void setAuthor(String author) {
		this.author = author;
		}
	public void setServer(String server) {
		this.server = server;
		}
	public void setNewsgroup(String newsgroup) {
		this.newsgroup = newsgroup;
		}
	public void setMessage(String message) {
		this.message = message;
		}
	public void setSubject(String subject) {
		this.subject = subject;
		}
	public void setVisible(boolean visible) {
		constructMessage();
		super.setVisible(visible);
		}
	public void constructMessage() {
		StringBuffer textBuffer = new StringBuffer();
		textBuffer.append("Header: " + header+"\n");
		textBuffer.append("Server: " + server+"\n");
		textBuffer.append("Newsgroup: " + newsgroup+"\n");
		textBuffer.append("Author: " + author+"\n");
		textBuffer.append("Subject: " + subject+"\n");
		textBuffer.append(message+"\n");
		editorPane.setText(textBuffer.toString());
		}
	}