import org.datamanager.tools.Information;
import org.datamanager.passiveentityvalue.*;
import org.datamanager.constraint.*;
import org.datamanager.exception.*;
import org.datamanager.event.*;
import org.datamanager.kernel.*;

import org.datamanager.engine.*;
import org.datamanager.engine.cluster.*;
import org.datamanager.engine.tools.*;

/**
 * This simpleton mission is to show what is to show what UI would get.
 *
 * @author Aleksander Slominski
 */
public class EngineListenSimpleton extends Simpleton implements EventHandler {

    /** Constructor does not take any parameters. */
    public EngineListenSimpleton() {
    }

    public Information getInformation() {
	String[] authors = {"Aleksander Slominski"};
	return new Information("1-EngineListen","short", "long", "1.0", authors);
    }

    public void process() {
	trace("processing started");
	org.datamanager.tools.Debug.setDebugger(false);
	try {
	    EventConstraint constraint = new OrConstraint(new EventTypeIsConstraint(EngineClusterCreatedEvent.class), new EventTypeIsConstraint(EngineClusteredEntityEvent.class));
	    Pool.getDefaultPool().subscribe(this, constraint);
	}
	catch (DataManagerException ex) {
	    trace("process exception:"+ex);
	}
    }

    public synchronized void handle(DataManagerEvent event) {
	synchronized(Engine.class) {
	try {
	    //EngineClusterCreatedEvent ecce = (EngineClusterCreatedEvent) event;
	    if(event instanceof EngineClusteredEntityEvent) {
		EngineClusteredEntityEvent ec2e = ( EngineClusteredEntityEvent ) event;
		Cluster c = (Cluster) ec2e.getCluster().getValue();
		Entity e= ec2e.getEntity();
		trace("added entity "+e.getName()+" to cluster "+c.getName());
		c.removeEntities(new Entity[]{e});
		c.addEntities(new Entity[]{e});
		Entity[] el = c.getEntities();
		for(int i = 0; i < el.length; ++i) {
		    //trace("cluster "+c.getName()+" has entity "+el[i].getName());
		}
	    } else {
		trace("listenv event:"+event);
	    }

	} catch (DataManagerException ex) {
	    trace("handle exception:"+ex);
	}    
	}
    }

    private void trace(String s) {
	Trace.println(this.getClass(), s);
    }
}
