import org.datamanager.kernel.*;

import org.datamanager.constraint.EntityConstraint;

import org.datamanager.passiveentityvalue.*;

import org.datamanager.exception.DataManagerException;

import org.datamanager.tools.SanitySimpleton;

import org.datamanager.tools.Information;

import org.datamanager.tools.Debug;

public class EntityAttributeSanitySimpleton extends SanitySimpleton
	{
	public void sanityTestSuite()
		throws DataManagerException
		{
		  Entity doc = Entity.create("engine-test");
		  System.err.println("made doc entity");
		doc.setValue(new StringEntityValue("Hello there, this is a test!"));
		  System.err.println("set value of doc entity");
		Entity mimeType = Entity.create("mime-type");
		  System.err.println("made mime-type entity");
		mimeType.setValue(new StringEntityValue("text/html"));
		  System.err.println("set value of mime-type entity");
		doc.attach(mimeType);
		  System.err.println("attached mime-type to doc");
		Pool.getDefaultPool().add(mimeType); //(1)
		  System.err.println("added mime-type to the pool");
		Entity[] el = mimeType.getBases(EntityConstraint.NONE);
		  System.err.println("searched for mime-type's bases");
		}

	public Information getInformation()
		{
		String name = "EntityAttributeSanitySimpleton";
		String shortDescription =
			"Tests the sanity of entities.";
		String longDescription =
			"This class tests the sanity of the Entity class.";
		String version = "1.0";
		String[] authors = {"Ben Keil", "Matthew Farrellee"};
		return new Information(
			name,
			shortDescription,
			longDescription,
			version,
			authors);
		}
	}







