import org.datamanager.kernel.Entity;

import org.datamanager.kernel.EntityValue;
import org.datamanager.passiveentityvalue.NullEntityValue;
import org.datamanager.passiveentityvalue.NumericEntityValue;
import org.datamanager.passiveentityvalue.DoubleEntityValue;

import org.datamanager.exception.DataManagerException;

import org.datamanager.tools.Information;

import org.datamanager.tools.SanitySimpleton;
import org.datamanager.tools.Debug;


public class EntityValueSanitySimpleton extends SanitySimpleton
	{
	public void sanityTestSuite()
		throws DataManagerException
		{
		NullEntityValueTest();
	
		DoubleEntityValueTest();
		}

	private void NullEntityValueTest()
		{
		Debug.assert("EnVa: EntityValue Sanity Test");
		Debug.assert("EnVa: Testing NullEntityValue!");
		EntityValue one = new NullEntityValue();
		Debug.assert("EnVa: EntityValue one = new NullEntityValue();");
		EntityValue two = new NullEntityValue();
		Debug.assert("EnVa: EntityValue two = new NullEntityValue();");
		Debug.assert("EnVa: one.equals(two) : " + one.equals(two));
		}

	private void DoubleEntityValueTest()
		{
		Debug.assert("Testing DoubleEntityValue!");
		Debug.assert("EnVa: EntityValue three = " + 
					"new DoubleEntityValue(3);");
		EntityValue three = new DoubleEntityValue(3);
		Debug.assert("EnVa: NumericEntityValue four = " + 
					"new DoubleEntityValue(4.5);");
		NumericEntityValue four = new DoubleEntityValue(4.5);
 		Debug.assert("EnVa: DoubleEntityValue five = " + 
					"new DoubleEntityValue(4.5);");
		DoubleEntityValue five = new DoubleEntityValue(4.5);

		Debug.assert("EnVa: three.equals(four) : " + three.equals(four));
		Debug.assert("EnVa: four.equals(five)  : " + four.equals(five));

		Debug.assert("EnVa: four.subtract(new DoubleEntityValue(1.5));");
		four.subtract(new DoubleEntityValue(1.5));
		Debug.assert("EnVa: four.equals(three) : " + four.equals(three));

		Debug.assert("EnVa: five.multiplyBy(2);");
		five.multiplyBy(2);
		Debug.assert("EnVa: five.divideBy(3.0);");
		five.divideBy(3.0);
		Debug.assert("EnVa: five : " + five + "... equals(four) : " +
					five.equals(four));
		}

	public Information getInformation()
		{
		String name = "EntityValueSanitySimpleton";
		String shortDescription =
			"Tests the sanity of Entity and EntityValue";
		String longDescription =
			"Tests the sanity of Entity and EntityValue";
		String version = "1.0";
		String[] authors = {"Ben Keil", "Matthew Farrellee"};
		return new Information(
			name,
			shortDescription,
			longDescription,
			version,
			authors);
		}


	}







