import org.datamanager.kernel.*;
import org.datamanager.constraint.*;
import org.datamanager.passiveentityvalue.*;
import org.datamanager.exception.*;
import org.datamanager.tools.*;

import org.datamanager.tools.Debug;

public class PoolDumpSanitySimpleton extends SanitySimpleton
	{

	public void sanityTestSuite()
		throws DataManagerException
		{
		try
			{
			Thread.sleep(3 * 1000);
			}
		catch (Exception e)
			{
			e.printStackTrace();
			}
		Pool pool = Pool.getDefaultPool();
	
		Entity[] entities;

		entities = pool.search(EntityConstraint.NONE);

		Debug.assert("PDSS: entities.length==" + entities.length);
		Debug.assert("PDSS: starting to display entities");
		for (int index = 0; index < entities.length; index++)
			{
			Debug.assert("PDSS: " +
						entities[index]);
			}

		Debug.assert("PDSS: finished displaying entities");
		}


	public Information getInformation()
		{
		String name = "PoolDumpSanitySimpleton";
		String shortDescription =
			"Dump all the entities to the screen.";
		String longDescription =
			"This simpletons takes all the entities in the default " +
			"pool and prints them to the screen.";
		String version = "1.0";
		String[] authors = {"Matthew Farrellee","Ben Keil"};

		return new Information(
			name,
			shortDescription,
			longDescription,
			version,
			authors);
		}
	}
